---
title: 'Element: focus event'
slug: Web/API/Element/focus_event
tags:
  - API
  - DOM
  - Element
  - Event
  - Focus
  - FocusEvent
  - Reference
---
<div>{{APIRef}}</div>

<p>The <strong><code>focus</code></strong> event fires when an element has received focus. The main difference between this event and {{domxref("Element/focusin_event", "focusin")}} is that <code>focusin</code> bubbles while <code>focus</code> does not.</p>

<p>The opposite of <code>focus</code> is {{domxref("Element/blur_event", "blur")}}.</p>

<table class="properties">
 <tbody>
  <tr>
   <th scope="row">Bubbles</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Cancelable</th>
   <td>No</td>
  </tr>
  <tr>
   <th scope="row">Interface</th>
   <td>{{DOMxRef("FocusEvent")}}</td>
  </tr>
  <tr>
   <th scope="row">Event handler property</th>
   <td>{{domxref("GlobalEventHandlers/onfocus", "onfocus")}}</td>
  </tr>
  <tr>
   <th scope="row">Sync / Async</th>
   <td>Sync</td>
  </tr>
  <tr>
   <th scope="row">Composed</th>
   <td>Yes</td>
  </tr>
 </tbody>
</table>

<h2 id="Examples">Examples</h2>

<h3 id="Simple_example">Simple example</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;form id="form"&gt;
  &lt;input type="text" placeholder="text input"&gt;
  &lt;input type="password" placeholder="password"&gt;
&lt;/form&gt;</pre>

<h4 id="JavaScript">JavaScript</h4>

<pre class="brush: js notranslate">const password = document.querySelector('input[type="password"]');

password.addEventListener('focus', (event) =&gt; {
  event.target.style.background = 'pink';
});

password.addEventListener('blur', (event) =&gt; {
  event.target.style.background = '';
});</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Simple_example", '100%', '50px')}}</p>

<h3 id="Event_delegation">Event delegation</h3>

<p>There are two ways of implementing event delegation for this event: by using the {{Event("focusin")}} event, or by setting the <code>useCapture</code> parameter of {{domxref("EventTarget.addEventListener()", "addEventListener()")}} to <code>true</code>.</p>

<h4 id="HTML_2">HTML</h4>

<pre class="brush: html notranslate">&lt;form id="form"&gt;
  &lt;input type="text" placeholder="text input"&gt;
  &lt;input type="password" placeholder="password"&gt;
&lt;/form&gt;</pre>

<h4 id="JavaScript_2">JavaScript</h4>

<pre class="brush: js notranslate">const form = document.getElementById('form');

form.addEventListener('focus', (event) =&gt; {
  event.target.style.background = 'pink';
}, true);

form.addEventListener('blur', (event) =&gt; {
  event.target.style.background = '';
}, true);</pre>

<h4 id="Result_2">Result</h4>

<p>{{EmbedLiveSample("Event_delegation", '100%', '50px')}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName("UI Events", "#event-type-focus")}}</td>
   <td>{{Spec2("UI Events")}}</td>
   <td>Added info that this event is composed.</td>
  </tr>
  <tr>
   <td>{{SpecName("DOM3 Events", "#event-type-focus")}}</td>
   <td>{{Spec2("DOM3 Events")}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Element.focus_event")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>Related events: {{domxref("Element/blur_event", "blur")}}, {{domxref("Element/focusin_event", "focusin")}}, {{domxref("Element/focusout_event", "focusout")}}</li>
 <li>This event on <code>Window</code> targets: {{domxref("Window/focus_event", "focus")}} event</li>
</ul>
